# Need to use real data to estimate parameters.
# de.prob = 0.1 is the default.
params <- newSplatParams(group.prob = rep(0.2, 5))
sim <- splatSimulate(params, method = "groups")
sim

extract_de_inds <- function(sce) {
  stopifnot(is(sce, "SingleCellExperiment"))

  n_groups <- length(unique(colData(sce)$Group))
  col_names <- paste0("DEFacGroup", 1:n_groups)
  data <- rowData(sce)[, col_names]

  out <- lapply(data, function(x) which(x != 1))

  names(out) <- paste0("group_", 1:n_groups)
  out
}

out <- extract_de_inds(sim)
str(out)

# Why does this warn??
clusters <- quickCluster(sim)
sim <- computeSumFactors(sim, clusters = clusters)
sim <- logNormCounts(sim)

colLabels(sim) <- colData(sim)$Group

scran_markers <- findMarkers(sim)



group_1_markers <- scran_markers[[1]][scran_markers[[1]]$FDR < 0.05, ]
group_1_markers <- readr::parse_number(rownames(group_1_markers))

length(intersect(out$group_1, group_1_markers))

length(setdiff(out$group_1, group_1_markers))
length(setdiff(group_1_markers, out$group_1))

out$group_1

